//	AppMenu.h
//
//	Tetsuo Yamada
//
//	Application Menu (which shows smiling-mark) and its item, AppMenuItem.

#ifndef		FB_APP_MENU_h_
#define		FB_APP_MENU_h_

#include	"FBBase.h"
#include	"LayerInfo.h"
#include	<interface/MenuBar.h>
#include	<interface/Bitmap.h>
#include	<interface/MenuItem.h>

class		AppMenu ;

//=============================================================
//	class AppMenuItem
//=============================================================
class AppMenuItem : public BMenuItem {
//	friends
friend class				AppMenu ;

//	variables
private :
	BBitmap*				fIcon ; // SMILE!!
	
//	methods
public :
							AppMenuItem () ;
							~AppMenuItem () ;
	
	virtual void			GetContentSize (float *width, float *height) ;
	
	//	re-define IsSelected() to make it public.
	bool					IsSelected2 () const ;
	
protected :
	virtual void			DrawContent () ;
} ;

//=============================================================
//	class AppMenu
//=============================================================
class AppMenu : public BMenuBar {
/* variables */
private :
	BMenu*					fLayerMenu ; // menu for "switch layer"
	BMenu*					fSpaceMenu ; // menu for "switch workspace"
	
/* methods */
public :
							AppMenu () ;
							~AppMenu () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			ResizeToPreferred () ;
	virtual void			MouseMoved (BPoint p, uint32 t, const BMessage *msg) ;
	virtual void			WindowActivated (bool active) ;
	virtual void			MessageReceived (BMessage *msg) ;
	virtual void			MouseDown (BPoint p) ;
	virtual void			Draw (BRect update) ;
	
	//	updates items to adjust to the current state.
	void					Modify () ;
	
private :
	void					BuildItems () ;
	
	//	currently not used.
	void					UpdateIcon () ;
} ;

#endif

