//	BarWindow.h
//
//	Tetsuo Yamada
//
//	Main window and its message filters.
//	chores_slave thread.

#ifndef		FB_BAR_WINDOW_h_
#define		FB_BAR_WINDOW_h_


#include	"FBBase.h"
#include	"LayerBar.h"
#include	"AppMenu.h"
#include	"LayerInfo.h"
#include	"LayerItem.h"
#include	"FBShelf.h"
#include	<app/MessageFilter.h>
#include	<app/Application.h>


class		BarWindow ;
class		KeyDownFilter ;
class		KeyUpFilter ;


/*
void						PrintKeyMessage (const char *text, 
									const BMessage *message) ;
*/

//==================================================================
//	class KeyDownFilter
//==================================================================
class KeyDownFilter : public BMessageFilter {
// fields
private : 
	BarWindow*				fOwner ;
	
// methods
public : 
							KeyDownFilter (BarWindow *owner) ;
							~KeyDownFilter () ;
	
	virtual filter_result	Filter (BMessage *message, BHandler **target) ;
} ;

//==================================================================
//	class KeyUpFilter
//==================================================================
class KeyUpFilter : public BMessageFilter {
// fields
private : 
	BarWindow*				fOwner ;
	
// methods
public : 
							KeyUpFilter (BarWindow *owner) ;
							~KeyUpFilter () ;
	
	virtual filter_result	Filter (BMessage *message, BHandler **target) ;
	
private : 
	BMenuBar*				NextMenuBar (bool positive) const ;
} ;

//==================================================================
//	class BarWindow
//==================================================================
class BarWindow : public LayerManager {
// friends
friend class				KeyDownFilter ;
friend class				KeyUpFilter ;

// fields 
private : 
	LayerBar*				fLayerBar ;
	AppMenu*				fAppMenu ;
	ShelfBar*				fShelfBar ;
	FBShelf*				fShelf ;
	thread_id				fChores ; // chores_slave
	bool					fShelfShown ; // the shelf is shown ?
	
// methods
public : 
							BarWindow () ;
							~BarWindow () ;
	
	virtual bool			QuitRequested () ;
	virtual void			DispatchMessage (BMessage *msg, BHandler *handler) ;
	virtual void			MessageReceived (BMessage *msg) ;
	virtual void			WindowActivated (bool active) ;
	virtual void			WorkspaceActivated (int32 workspace, bool active) ;
	virtual void			ScreenChanged (BRect frame, color_space mode) ;
	virtual void			Show () ;
	virtual void			Quit () ;
	
	virtual void			UpdateSettings (settings *s) ;
	
	bool					IsShowingShelf () const ;
	
private : 
	static status_t			Chores (void *data) ; // thread_func
	void					ChoreTask () ; // called from Chores()
	
	//	move, resize window to adjust its settings.
	void					Reshape (bool maximize) ;
	
	void					SwitchLayer (BMessage *msg) ;
} ;

#endif

