//	FakeBar.h
//
//	Tetsuo Yamada
//
//	Application object and main function.

#ifndef		FB_FAKE_BAR_h_
#define		FB_FAKE_BAR_h_

#include	"FBBase.h"
#include	"IOSlave.h"
#include	"BarWindow.h"
#include	"PrefsWindow.h"
#include	"HotKeyWindow.h"
#include	<app/Application.h>

//	creates (RefRetriever**) item referring a file whose path is (const char*) path
//	LayerInfo* info is used to determine the type of the instance.
status_t					create_ref_item (const char *path, 
									LayerInfo *info, 
									RefRetriever** item) ;

//==============================================================
//	class FakeBar
//==============================================================
class FakeBar : public BApplication {
//	friends
friend class				BarWindow ;

//	fields
private : 
	IOSlave*				fSlave ;
	PrefsWindow*			fPrefs ;
	uint8*					fHotKey ;
	
//	methods
public : 
							FakeBar (bool convert, bool option) ;
							~FakeBar () ;
	
	virtual void			MessageReceived (BMessage *msg) ;
	virtual bool			QuitRequested () ;
	virtual void			AboutRequested () ;
	virtual void			ReadyToRun () ;
	
private : 
	//	launching routines
	void					Open (BMessage *msg) const ;
	void					OpenParent (BMessage *msg) const ;
	void					OpenWith (BMessage *msg) const ;
	
	//	show alert dialog when something goes wrong...
	void					ShowDialog (BMessage *msg) ;
	
	//	converts settings from v1.0.4 of it to v1.1.x
	void					ConvertSettings () const ;
} ;

#endif

