//	ClickControl.h
//
//	Tetsuo Yamada
//
//	the abstract base class for GUIs which displays an image on the left, 
//	and a label on the right, such as BRadioButton, BCheckBox...
//	this class implements asynchronous mouse tracking based on R4.
//	but there's no BeBook (for R4) now, there can be bad lines.

#ifndef		P_CLICK_CONTROL_h_
#define		P_CLICK_CONTROL_h_


#include	<interface/Control.h>
#include	"GUIBase.h"


//===================================================================
//	class ClickControl
//===================================================================
class ClickControl : public BControl {

/* variables */
private :
	BRect				fImageRect ;

/* constructor & destructor */
public :
							ClickControl (BRect frame, 
									const char *name, 
									const char *label, 
									float imageWidth, 
									float imageHeight, 
									BMessage *message, 
									uint32 mode, 
									uint32 flags) ;
	virtual					~ClickControl () ;
	
	virtual void			Draw (BRect update) ;
	virtual void			MouseDown (BPoint p) ;
	virtual void			MouseMoved (BPoint p, uint32 t, const BMessage *msg) ;
	virtual void			KeyDown (const char *bytes, int32 numBytes) ;
	virtual void			AttachedToWindow () ;
	virtual void			GetPreferredSize (float *width, float *height) ;
	
	// overwrite this hook.
	// returned value will become a current value.
	virtual int32			ValueForPoint (BPoint p, BRect imageRect) const = 0 ;
	virtual int32			ValueForKey (const char *bytes, int32 numBytes) const = 0 ;
	
protected :
	virtual void			DrawImage (BRect imageRect) = 0 ;
	virtual void			SetImageSize (float width, float height) ;
	
	void					GetImageSize (float *width, float *height) const ;
} ;

#endif

