//	DirectoryMenu.h
//
//	Tetsuo Yamada
//
//	Menu which can list entries in the specified directory.

#ifndef		P_DIRECTORY_MENU_h_
#define		P_DIRECTORY_MENU_h_


#include	<interface/Menu.h>
#include	<storage/Directory.h>
#include	"GUI/FileMenuItem.h"
	

//===========================================================
//	class DirectoryMenu
//===========================================================
class DirectoryMenu : public BMenu {
//	fields
private : 
	entry_ref				fDirRef ;
	BDirectory				fDir ; // is set only when dynamically adding.
	bool					fIsRoot ; // is this object the root in the *DirectoryMenu hierarchy* ?
	/*	fIsRoot is used when we clear all items added to this */
	
//	methods
public : 
							//	layout must be either column or row.
							DirectoryMenu (const BDirectory *dir, 
									menu_layout layout = B_ITEMS_IN_COLUMN) ;
	virtual					~DirectoryMenu () ;
	
	//	this wonderful method can build DirectoryMenu hierarchy 
	//	starting from the specified node.
	//	BMessage *message is a model message for the MenuItem.
	static FileMenuItem*	StartHierarchy (const char *path, 
									BMessage *message) ;
	static FileMenuItem*	StartHierarchy (const entry_ref *ref, 
									BMessage *message) ;
	
	//	returns B_INTERRUPTED, if it is diplayed or dynamically adding.
	//	not reliable
	virtual status_t		SetDirectory (const BDirectory *dir) ;
	
	status_t				GetDirectory (BDirectory *dir) const ;
	
protected : 
	virtual bool			AddDynamicItem (add_state state) ;
	
	// remove and delete all items.
	void					RemoveAllItems () ;
	
	bool					AddNextItem () ;
} ;

#endif

