//	FileMenuItem.h
//
//	Tetsuo Yamada
//
//	MenuItem class represents the directory entries.

#ifndef		P_FILE_MENU_ITEM_h_
#define		P_FILE_MENU_ITEM_h_


#include	"GUIBase.h"
#include	"fs/RefRetriever.h"
#include	<interface/MenuItem.h>
#include	<interface/Bitmap.h>

//==================================================================
//	class FileMenuItem
//==================================================================
class FileMenuItem : public RefRetriever, public BMenuItem {

/* variables */
private :
	BBitmap*				fIcon ;
	bool					fEnabled ;
	
/* constructor & destructor */
public :
							FileMenuItem (const entry_ref *ref, 
									BMessage *msg) ;
							FileMenuItem (const entry_ref *ref, 
									BMenu *submenu, 
									BMessage *msg = NULL) ;
							FileMenuItem (const char *path, 
									BMessage *msg) ;
							FileMenuItem (const char *path, 
									BMenu *submenu, 
									BMessage *msg = NULL) ;
							FileMenuItem (const RefRetriever *ref, 
									BMessage *msg) ;
							FileMenuItem (const RefRetriever *ref, 
									BMenu *submenu, 
									BMessage *msg = NULL) ;
							FileMenuItem (BMessage *archive) ;
	virtual					~FileMenuItem () ;
	
/* methods */
public :
	static FileMenuItem*	Instantiate (BMessage *archive) ;
	virtual status_t		Archive (BMessage *msg, bool deep = true) const ;
	
	virtual void			GetContentSize (float *width, float *height) ;
	
	const BBitmap*			Icon () const ;
	
	//	re-define IsSelected() to make it public.
	bool					IsSelected2 () const ;
	//	Is the path is legal ?
	bool					IsEnabled2 () const ;
	
protected :
	virtual status_t		RefUpdated () ;
	virtual void			DrawContent () ;
	
	/*	the message this object's Invoke() invokes does NOT contains 
		int32 named "index" field. It is not good, but necessary. */
	virtual status_t		Invoke (BMessage *msg = NULL) ;
} ;

#endif

