//	GUIBase.cpp
//
//	Tetsuo Yamada

#include	"GUIBase.h"


void stroke_3d_rect (BView *aView, BRect rect, rgb_color color, bool raised) {
	rgb_color high = aView->HighColor () ;
	
	if (raised) aView->SetHighColor (tint_color (color, B_LIGHTEN_2_TINT)) ;
	else aView->SetHighColor (tint_color (color, B_DARKEN_1_TINT)) ;
	aView->StrokeLine (rect.RightTop(), rect.LeftTop()) ;
	aView->StrokeLine (rect.LeftBottom()) ;
	
	if (raised) aView->SetHighColor (tint_color (color, B_DARKEN_1_TINT)) ;
	else aView->SetHighColor (tint_color (color, B_LIGHTEN_2_TINT)) ;
	aView->StrokeLine (rect.RightBottom()) ;
	aView->StrokeLine (rect.RightTop()) ;
	
	aView->SetHighColor (high) ;
} ;

BRect layout (BPoint p, BView *target, alignment h_align, vertical_alignment v_align) {
	BRect rect (0, 0, 0, 0) ;
	target->GetPreferredSize (&(rect.right), &(rect.bottom)) ;
	target->ResizeTo (rect.right, rect.bottom) ;
	
	switch (h_align) {
		case B_ALIGN_LEFT : 
			rect.OffsetBy (p.x, 0) ;
			break ;
		case B_ALIGN_CENTER : 
			rect.OffsetBy (p.x - rect.right/2, 0) ;
			break ;
		case B_ALIGN_RIGHT : 
			rect.OffsetBy (p.x - rect.right, 0) ;
			break ;
	}
	switch (v_align) {
		case B_ALIGN_TOP : 
			rect.OffsetBy (0, p.y) ;
			break ;
		case B_ALIGN_MIDDLE : 
			rect.OffsetBy (0, p.y - rect.bottom/2) ;
			break ;
		case B_ALIGN_BOTTOM : 
			rect.OffsetBy (0, p.y - rect.bottom) ;
			break ;
	}
	target->MoveTo (rect.left, rect.bottom) ;
	return rect ;
} ;

rgb_color ui_color2 (int32 which) {
	rgb_color c ;
	switch (which) {
		case P_STANDARD_GRAY : 
			c.red = c.green = c.blue = 216 ;
			return c ;
		case P_LIGHT_GRAY : 
			c.red = c.green = c.blue = 232 ;
			return c ;
		case P_BE_BLUE : 
			c.red = c.green = 0 ;
			c.blue = 154 ;
			return c ;
		case P_BE_RED : 
			c.green = c.blue = 51 ;
			c.red = 203 ;
			return c ;
		default : 
			return ui_color ((color_which)which) ;
	}
	return c ;
} ;