//	GUIBase.h
//
//	Tetsuo Yamada
//
//	The collection of global functions and constants for GUI.

#ifndef		P_GUI_BASE_h_
#define		P_GUI_BASE_h_


#include	<app/Message.h>
#include	<interface/View.h>
#include	<interface/Screen.h>
#include	<interface/Window.h>
#include	<string.h>
#include	<stdlib.h>
#include	<stdio.h>

//==================================================================
//	Constant definitions
//==================================================================
#define		P_GUI_ERRORS_BASE	B_ERRORS_END + 30
#define		P_GUI_ERRORS_END	P_GUI_ERRORS_BASE + 9

#define		P_MINI_RECT			BRect (0, 0, 15, 15)
#define		P_LARGE_RECT		BRect (0, 0, 31, 31)


//------------------------------------------------------------------
//	domestic colors
//------------------------------------------------------------------
enum {
	P_STANDARD_GRAY = -10, 	// 216, 216, 216
	P_LIGHT_GRAY, 			// 232, 232, 232
	P_BE_BLUE, 				// 0, 0, 154
	P_BE_RED, 				// 203, 51, 51
} ;

//==================================================================
//	globals
//==================================================================
//	returns true if two colors are the same.
bool						compare (rgb_color c1, 
									rgb_color c2, 
									bool compAlpha = true) ; // inline

//	returns ui_color() and more...
rgb_color					ui_color2 (int32 which) ;

void						stroke_3d_rect (BView *view, 
									BRect rect, 
									rgb_color color, 
									bool raised = true) ;
	
void						reshape_window (BWindow *window, 
									float width, 
									float height, 
									float vps) ; // inline

BRect						layout (BPoint position, 
									BView *target, 
									alignment h_align = B_ALIGN_LEFT, 
									vertical_alignment v_align = B_ALIGN_TOP) ;

//==================================================================
//	inline globals implementation
//==================================================================
inline bool compare (rgb_color c1, rgb_color c2, bool alpha) {
	bool result = (c1.red==c2.red && c1.green==c2.green && c1.blue==c2.blue) ;
	if (alpha) result = (result && c1.alpha==c2.alpha) ;
	return result ;
} ;

inline void reshape_window (BWindow *window, float width, float height, float vps) {
	BRect frame = BScreen (window).Frame() ;
	window->MoveTo (	(frame.Width() - width)/2, 
						(frame.Height() - height)*vps) ;
} ;

#endif

