//	OpenWithMenu.h
//
//	Tetsuo Yamada
//
//	The (bad) duplication of Tracker's "Open With..."

#ifndef		P_OPEN_WITH_MENU_h_
#define		P_OPEN_WITH_MENU_h_


#include	<app/Invoker.h>
#include	<interface/Menu.h>
#include	"GUI/FileMenuItem.h"
#include	"fs/FindApps.h"


//===========================================================
//	class OpenWithMenu
//===========================================================
class OpenWithMenu : public BMenu, public BInvoker {
//	fields
private : 
	entry_ref				fRef ;
	BMessage				fInfo ;
	
//	methods
public : 
							OpenWithMenu (const entry_ref *ref, 
									BMessage *message, 
									menu_layout layout = B_ITEMS_IN_COLUMN) ;
	virtual					~OpenWithMenu () ;
	
	virtual void			AttachedToWindow () ;
	virtual status_t		SetMessage (BMessage *message) ;
	
	//	not reliable
	virtual status_t		SetEntryRef (const entry_ref *ref) ;
	const entry_ref*		EntryRef () const ;
	
protected : 
	virtual bool			AddDynamicItem (add_state state) ;
	
private : 
	// The only one reason this class derives BInvoker is that it's convenient.
	// So this class should not really invoke.
	virtual status_t		Invoke (BMessage *msg = NULL) ;
} ;

#endif

