//	HotKeyWindow.h
//
//	Tetsuo Yamada
//
//	The modal window to set hot key, its message filter 
//	and a view which displays the keys pressed by the user.

#ifndef		FB_HOT_KEY_WINDOW_h_
#define		FB_HOT_KEY_WINDOW_h_

#include	"FBBase.h"
#include	"GUIBase.h"
#include	<interface/Window.h>
#include	<interface/StringView.h>
#include	<interface/Button.h>
#include	<app/MessageFilter.h>


class		HotKeyWindow ;
class		KeyView ;

//==============================================================
//	function key_filter
//==============================================================
//	i want to dispatch ALL B_KEY_DOWN messages!!

filter_result				key_filter (BMessage *message, 
									BHandler **target, 
									BMessageFilter *filter) ;

//==============================================================
//	class KeyView
//==============================================================
class KeyView : public BView {
// friends
friend class				HotKeyWindow ;

// fields
private : 
	uint8**					fStates ;
	char*					fLabel ;
	
// method
public : 
							KeyView (BRect frame, uint8** states) ;
							~KeyView () ;
	
	virtual void			KeyDown (const char *bytes, int32 numBytes) ;
	virtual void			Draw (BRect update) ;
	virtual void			AttachedToWindow () ;
	
private : 
	// connect strings.
	void					Connect (char *string, char *add) ; // inlined
} ;

//==============================================================
//	class HotKeyWindow
//==============================================================
class HotKeyWindow : public BWindow {
// fields
private : 
	KeyView*				fKeyView ;
	BButton*				fSet ;
	BButton*				fUnset ;
	bool*					fEndFlag ;
	
// methods
public : 
							HotKeyWindow (uint8 **states, bool* endFlag) ;
							~HotKeyWindow () ;
	
	virtual bool			QuitRequested () ;
} ;


inline void KeyView::Connect (char *string, char *add) {
	if (strlen (string)>strlen (B_EMPTY_STRING)) strcat (string, " + ") ;
	strcat (string, add) ;
} ;

#endif

