//	IOSlave.h
//
//	Tetsuo Yamada
//
//	BLooper, named io_slave, to read/write files. 

#ifndef		FB_IO_SLAVE_h_
#define		FB_IO_SLAVE_h_


#include	"FBBase.h"
#include	"LayerInfo.h"
#include	"fs/RefRetriever.h"
#include	<app/Looper.h>
#include	<storage/Directory.h>


//	this function creates all layer items. implemented in FakeBar.cpp
extern status_t				create_ref_item (const char *path, 
									LayerInfo* info, 
									RefRetriever **item) ;

//==============================================================
//	class IOSlave
//==============================================================
class IOSlave : public BLooper {
// fields
private :
	BDirectory				fDir ; // is ~/config/settings/FakeBar
	
// methods
public :
							IOSlave () ;
							~IOSlave () ;
	
	virtual void			MessageReceived (BMessage *msg) ;
	
private :
	void					LoadLayer (BMessage *msg) ;
	void					SaveLayer (BMessage *msg) ;
	void					DeleteLayer (BMessage *msg) ;
	
	// called-from-LoadLayer() functions to interrupt loading.
	bool					CheckQueue (LayerInfo *info) ;
	void					ProcessMessage (BMessage *message, LayerInfo *target) ;
} ;

#endif

