//	LayerBar.h
//
//	Tetsuo Yamada
//
//	MenuBar which shows the current layer.

#ifndef		FB_LAYER_BAR_h_
#define		FB_LAYER_BAR_h_

#include	"FBBase.h"
#include	"LayerItem.h"
#include	"LayerInfo.h"
#include	<interface/MenuBar.h>
#include	<interface/Region.h>


//==============================================================
//	class LayerBar
//==============================================================
class LayerBar : public BMenuBar {
// fields
private :
	list_which				fCurrent ;
	LayerInfo*				fLayer ;
	int32					fSelection ;
	bigtime_t				fTimeForTrack ;
	
// methods
public : 
							LayerBar () ;
							~LayerBar () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			AllDetached () ;
	virtual void			MouseDown (BPoint p) ;
	virtual void			ResizeToPreferred () ;
	virtual void			Draw (BRect update) ;
	virtual void			MouseMoved (BPoint p, uint32 t, const BMessage *msg) ;
	virtual void			KeyDown (const char *bytes, int32 numBytes) ;
	virtual void			MessageReceived (BMessage *msg) ;
	
	//	returns index number of an item which is on (BPoint) p.
	int32					IndexAt (BPoint p) const ;
	
	LayerItem*				LayerItemAt (int32 index) const ;
	
	//	set/return current layer.
	LayerInfo*				Layer () const ;
	void					SetLayer (LayerInfo *info) ;
	
	//	this method enables dynamic adding.
	void					RescanItems () ;
	
	int32					Selection () const ;
	
private : 
	/* DropTrack is commented because FB_DROP_EXTENTION is not implemented
	void					DropTrack (BPoint p, uint32 t) ;*/
	
	//	calls item's Invoke() after graphical effect.
	void					LaunchLayerItem (LayerItem *item) ;
	
	//	install/de-install layer
	void					AttachLayer () ;
	void					DetachLayer () ;
} ;

#endif

