//	LayerSet.h
//
//	Tetsuo Yamada
//
//	View to configurate layers.

#ifndef		FB_LAYER_SET_h_
#define		FB_LAYER_SET_h_


#include	"FBBase.h"
#include	"LayerInfo.h"
#include	"GUIBase.h"
#include	"GUI/MatrixListView.h"
#include	"GUI/MatrixListItem.h"
#include	"GUI/TextDialog.h"
#include	<interface/Button.h>
#include	<interface/ScrollView.h>
#include	<interface/MenuField.h>
#include	<support/Beep.h>


class		PrefsWindow ;

bool						confirm_entry (const char *name, void *extra) ;


//==========================================================
//	class LayerSet
//==========================================================
class LayerSet : public BView {
// friends
friend class				PrefsWindow ;

// fields
private : 
	LayerInfo*				fCrtLayer ;
	bool					fChanged ;
	
	// children
	BStringView*			fLayerName ;
	MatrixListView*			fListView ;
	BButton*				fAddItem ;
	BButton*				fRemoveItem ;
	BButton*				fRenameLayer ;
	BButton*				fRemoveLayer ;
	
	BButton*				fNewLayer ;
	BMenuField*				fLayerField ;
	
// methods
public : 
							LayerSet () ;
							~LayerSet () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			MessageReceived (BMessage *msg) ;
	
	void					RescanItems () ;
	
private : 
	void					SelectLayer (const char *name) ;
	void					BuildMenu () const ;
	
	// message handling
	void					RemoveItem () ;
	void					ItemAdded (BMessage *msg) ;
	void					ItemMoved (BMessage *msg) ;
	void					ItemDropped (BMessage *msg) ;
	void					RefsReceived (BMessage *msg) ;
} ;

#endif

