//	PrefsWindow.h
//
//	Tetsuo Yamada
//
//	Preferences window object

#ifndef		FB_PREFS_WINDOW_h_
#define		FB_PREFS_WINDOW_h_


#include	"FBBase.h"
#include	"LayerInfo.h"
#include	"WindowSet.h"
#include	"WorkspaceSet.h"
#include	"LayerSet.h"
#include	"TargetSet.h"
#include	"MiscSet.h"
#include	"IOSlave.h"
#include	<storage/FilePanel.h>
#include	<interface/Button.h>
#include	<interface/ListView.h>
#include	<interface/ListItem.h>
#include	<interface/StringView.h>
#include	<interface/CheckBox.h>
#include	<interface/Box.h>


//================================================================
//	class PrefsWindow
//================================================================
class PrefsWindow : public LayerManager {
// friends
friend class				LayerSet ;

// fields
private : 
	// cached data, which enables "Revert"
	settings				fTmpSettings ;
	
	// related open panel
	BFilePanel*				fPanel ;
	entry_ref				fPanelDir ;
	BMessenger*				fMessenger ;
	
	// each setting views
	WindowSet*				fWindow ;
	WorkspaceSet*			fWorkspace ;
	LayerSet*				fLayer ;
	TargetSet*				fTarget ;
	MiscSet*				fMisc ;
	
	// views
	BButton*				fSet ;
	BButton*				fCancel ;
	BButton*				fRevert ;
	BListView*				fList ;
	BBox*					fBox ;
	BCheckBox*				fRemember ;
	
public : 
							PrefsWindow () ;
							~PrefsWindow () ;
	
	virtual void			DispatchMessage (BMessage *msg, BHandler *handler) ;
	virtual bool			QuitRequested () ;
	virtual void			Quit () ;
	virtual void			MessageReceived (BMessage *msg) ;
	
private : 
	void					BuildChildren (float width, float height) ;
	
	//	set the section such as Window, Workspaces, Layers,...
	void					SetControl (int32 index) ;
	void					Revert () ;
	void					Set () ;
	
	LayerInfo*				CreateLayer (const char *name) ;
	bool					DeleteLayer (const char *name) ;
} ;

#endif

