//	TargetSet.h
//
//	Tetsuo Yamada
//
//	View to configurate targets

#ifndef		FB_TARGET_SET_h_
#define		FB_TARGET_SET_h_


#include	"FBBase.h"
#include	"LayerInfo.h"
#include	"GUI/MatrixListView.h"
#include	"GUI/MatrixListItem.h"
#include	<interface/Button.h>
#include	<interface/ScrollView.h>


//==========================================================
//	class TargetSet
//==========================================================
class TargetSet : public BView {
// friends
friend class				PrefsWindow ;

// fields
private : 
	LayerInfo*				fTargets ;
	bool					fChanged ;
	
	// children
	MatrixListView*			fListView ;
	BButton*				fAddItem ;
	BButton*				fRemoveItem ;
	
//	methods
public : 
							TargetSet (LayerManager *manager) ;
							~TargetSet () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			MessageReceived (BMessage *msg) ;
	virtual void			DetachedFromWindow () ;
	
	void					RescanItems () ;
	
private : 
	void					RemoveItem () ;
	void					ItemAdded (BMessage *msg) ;
	void					ItemMoved (BMessage *msg) ;
	void					ItemDropped (BMessage *msg) ;
	void					RefsReceived (BMessage *msg) ;
} ;

#endif

