//	WindowSet.h
//
//	Tetsuo Yamada
//
//	View to configurate FakeBar's interface, appearances, etc...

#ifndef		FB_WINDOW_SET_h_
#define		FB_WINDOW_SET_h_

#include	"FBBase.h"
#include	"GUI/GUIBase.h"
#include	"GUI/ClickControl.h"
#include	<interface/MenuField.h>
#include	<interface/CheckBox.h>
#include	<interface/MenuItem.h>

class		PrefsWindow ;


//==========================================================
//	class DirectionControl
//==========================================================
class DirectionControl : public ClickControl {
// methods
public : 
							DirectionControl (BRect frame, 
									const char *name, 
									BMessage *message, 
									uint32 mode = B_FOLLOW_LEFT|B_FOLLOW_TOP) ;
							~DirectionControl () ;
	
	virtual int32			ValueForPoint (BPoint p, BRect imageRect) const ;
	virtual int32			ValueForKey (const char* bytes, int32 numBytes) const ;
	
protected : 
	virtual void			DrawImage (BRect imageRect) ;
} ;

//==========================================================
//	class LocationControl
//==========================================================
class LocationControl : public ClickControl {
// methods
public : 
							LocationControl (BRect frame, 
									const char *name, 
									BMessage *message, 
									uint32 mode = B_FOLLOW_LEFT|B_FOLLOW_TOP) ;
							~LocationControl () ;
	
	virtual int32			ValueForPoint (BPoint p, BRect imageRect) const ;
	virtual int32			ValueForKey (const char* bytes, int32 numBytes) const ;
	
protected : 
	virtual void			DrawImage (BRect imageRect) ;
} ;

//==========================================================
//	class WindowSet
//==========================================================
class WindowSet : public BView {
// friends
friend class				PrefsWindow ;

// fields
private : 
	settings*				fCrt ;
	BControl*				fCtrls[7] ;
	BMenuField*				fFields[2] ;
	
public : 
							WindowSet (settings *crt) ;
							~WindowSet () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			MessageReceived (BMessage *msg) ;
	
	void					GetMinimumSize (float *width, float *height) ;
	
	void					SettingsToViews () ;
	
private : 
	BMenu*					CreateMouseMenu () const ;
} ;

//	message "id"
//	0	location
//	1	direction
//	2	minimize
//	3	autofocus
//	4	drawLabel
//	5	drawBorder
//	6	which
//	100	forInvoke, forExpand

#endif

