//	WorkspaceSet.h
//
//	Tetsuo Yamada
//
//	View to configurate layers for each workspace.

#ifndef		FB_WORKSPACE_SET_h_
#define		FB_WORKSPACE_SET_h_


#include	"FBBase.h"
#include	"GUI/GUIBase.h"
#include	<interface/MenuField.h>
#include	<interface/Box.h>
#include	<interface/StringView.h>
#include	<interface/MenuItem.h>
#include	<interface/ScrollView.h>
#include	"LayerInfo.h"


class		WorkspaceSet ;

//==========================================================
//	class FBMenuField
//==========================================================
class FBMenuField : public BMenuField {
//	methods
public : 
							FBMenuField (BRect frame, const char *name, 
									const char *label, BMenu *menu, 
									uint32 mode = B_FOLLOW_LEFT|B_FOLLOW_TOP, 
									uint32 flags = B_WILL_DRAW|B_NAVIGABLE) ;
							~FBMenuField () ;
	
	virtual void			MakeFocus (bool focused) ;
} ;

//==========================================================
//	class WorkspaceSet
//==========================================================
class WorkspaceSet : public BView {
// friends

// fields
private : 
	settings*				fCrt ;
	int32					fCount ;
	BMenuField**			fFields ;
	BMenuField*				fAll ;
	
public : 
							WorkspaceSet (settings *crt) ;
							~WorkspaceSet () ;
	
	virtual void			AttachedToWindow () ;
	virtual void			MessageReceived (BMessage *msg) ;
	virtual void			FrameResized (float width, float height) ;
	
	void					SettingsToViews () ;
	
private : 
	void					BuildMenu (BMenuField *target, 
									int32 index, 
									BMessage *container) const ;
	void					AdjustScrollBar () ;
} ;

#endif

