//	FindApps.h
//
//	Tetsuo Yamada
//
//	To find supporting apps...

#ifndef		P_FIND_APPS_h_
#define		P_FIND_APPS_h_


#include	"FSBase.h"


//===================================================================
//	struct support_info
//===================================================================
typedef enum support_state {
	P_PREFERRED_APP = B_OK + 1, //	a preferred application
	P_SUPPORTING_APP, 			//	apps which supports ref's mime type
	P_SUPER_SUPPORT_APP, 		//	apps which supports ref's super mime type
	P_WILDCARD_APP				//	wildcard apps (supports all nodes)
} ;

struct support_info {
	entry_ref				ref ;
	char					signature [B_MIME_TYPE_LENGTH + 1] ;
	support_state			state ;
} ;

//===================================================================
//	find_supporting_apps
//===================================================================
/**	find applications which can open the specified ref,
	and fills container with support_info array. */
status_t find_supporting_apps (const entry_ref *ref, BMessage *container) ;

#endif

